﻿--[[
This code started life as Chronometer, an addon that tracks various spelleffects, sadly it lacked some stuff for locks
and while trying to patch it i ended up rewriting alot of it to serve as a warlock only dot tracker. Im pretty sure
there are bugs and quirky behaviors still in it, but it works as i think it should work and as all things, its a work
in progress.

CREDITS:
- Parser-1.1 and 2.0 for alot of code examples on event parsing.
- Chronometer for the initial code.
- SpellWatch

TODO:
- Test, test, test
--]]

local new, del
do
	local cache = setmetatable({},{__mode='k'})
	
	function new()
		local t = next(cache)
		if t then
			cache[t] = nil
			return t
		else
			return {}
		end
	end
	
	function del(t)
		for k, _ in pairs(t) do
			t[k] = nil
		end
		cache[t] = true
		return nil
	end
end

-- Stolen from Parser-2.0
local ConvertPattern =
	function(pattern)
		-- Add % to escape all magic characters used in LUA pattern matching, except $ and %
		pattern = pattern:gsub("([%^%(%)%.%[%]%*%+%-%?])","%%%1");
		
		-- Do these AFTER escaping the magic characters.
		pattern = pattern:gsub("%%s","(.-)"); -- %s to (.-)
        
        -- Anchor it, will improve matching speed
        pattern = "^"..pattern
		return pattern
	end

DarkCandy = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "CandyBar-2.0")
local DewDrop = AceLibrary("Dewdrop-2.0")
local PaintChips = AceLibrary("PaintChips-2.0")
local Media = AceLibrary("SharedMedia-1.0")

DarkCandy.SPELL = 1
DarkCandy.EVENT = 2

local timers = {}
local spellBars = {}
local activeSpells = {}
local complete = {}
local petcomplete = {}

local pattern =
{
	death = ConvertPattern(UNITDIESOTHER),
	aura_gone = ConvertPattern(AURAREMOVEDOTHER),
	pet_damage = ConvertPattern(SPELLCASTOTHERSTART),
	periodic = ConvertPattern(AURAADDEDOTHERHARMFUL),
	missed = ConvertPattern(SPELLMISSSELFOTHER),
	fail = ConvertPattern(SPELLIMMUNESELFOTHER),
	immune = ConvertPattern(IMMUNESPELLSELFOTHER),
	evade = ConvertPattern(SPELLEVADEDSELFOTHER),
	reflect = ConvertPattern(SPELLREFLECTSELFOTHER),
	resist = ConvertPattern(SPELLRESISTSELFOTHER)
}

DarkCandy.defaults = {
	scale = 1,
	growup = false,
	reverse = false,
	iconpos = "LEFT",
	fadeonkill = true,
	fadeonfade = true,
	pos = {},
	texture = "Blizzard",
	width = 255,
	height = 15,
	bgcolor = "00FF00",
	barcolor = "FF0000",
	bgalpha = 1,
}

DarkCandy.options = {
	type = "group",
	handler = DarkCandy,
	args = {
		anchor = {
			name = "Anchor", 
			desc = "Shows the dragable anchor.", 
			type = "execute", 
			func = function()
				if DarkCandy.anchor:IsVisible() then
					DarkCandy.anchor:Hide()
				else
					DarkCandy.anchor:Show()
				end
			end
		},
		bar = {
			name = "Bar",
			desc = "CandyBar options", 
			type = "group",
			args = {
				texture = {
					name = "Bar Texture", 
					desc = "Changes the texture of the timer bars.", 
					type = "text",
					get = function () return DarkCandy.db.profile.texture end,
					set = function (v) DarkCandy.db.profile.texture = v end,
					validate = Media:List('statusbar'),
				},
				color = {
					name = "Bar Color", 
					desc = "Set the default bar color.",
					type = "color",
					get = function()
						local _, r, g, b = PaintChips:GetRGBPercent(DarkCandy.db.profile.barcolor)
						return r, g, b 
					end,
					set = function(r, g, b, a) 
						local hex = DarkCandy:RGBToHex(r, g, b)
						PaintChips:RegisterHex(hex)
						DarkCandy.db.profile.barcolor = hex 
					end,
				},
				bgcolor = {
					name = "Background Color", 
					desc = "Set the bar background color.", 
					type = "color",
					get = function()
						local _, r, g, b = PaintChips:GetRGBPercent(DarkCandy.db.profile.bgcolor)
						return r, g, b 
					end,
					set = function(r, g, b, a) 
						local hex = DarkCandy:RGBToHex(r, g, b)
						PaintChips:RegisterHex(hex)
						DarkCandy.db.profile.bgcolor = hex 
					end,
				},
				bgalpha = {
					name = "Background Alpha",
					desc = "Alpha value of the bar background.",
					type = "range",
					get = function () return DarkCandy.db.profile.bgalpha end,
					set = function (v) DarkCandy.db.profile.bgalpha = v end,
					min = 0.0, max = 1.0,
				},
				scale = {
					name = "Bar Scale", 
					desc = "Set the bar scale.", 
					type = "range",
					get = function () return DarkCandy.db.profile.scale end,
					set = function (v) DarkCandy.db.profile.scale = v end,
					min = 0.5, max = 1.5,
				},
				height = {
					name = "Bar Height", 
					desc = "Set the bar height.", 
					type = "range",
					get = function () return DarkCandy.db.profile.height end,
					set = function (v) DarkCandy.db.profile.height = v end,
					min = 8, max = 30,
					step = 1,
				},
				width = {
					name = "Bar Width", 
					desc = "Set the bar width.", 
					type = "range",
					get = function () return DarkCandy.db.profile.width end,
					set = function (v) DarkCandy.db.profile.width = v end,
					min = 50, max = 300,
					step = 1,
				},
				growth = {
					name = "Bar Growth", 
					desc = "Toggles bar growing up or downwards.", 
					type = "toggle",
					get = function () return DarkCandy.db.profile.growup end,
					set = function (v) DarkCandy.db.profile.growup = v
					DarkCandy:SetCandyBarGroupGrowth("DarkCandy", DarkCandy.db.profile.growup) end,
				},
				reverse = {
					name = "Reverse", 
					desc = "Toggles if bars are reversed (fill up instead of emptying).", 
					type = "toggle",
					get = function() return DarkCandy.db.profile.reverse end,
					set = function(f) DarkCandy.db.profile.reverse = f end,
				},
				iconpos = {
					name = "Icon position", 
					desc = "Sets the icon position of the bar.", 
					type = "text",
					get = function () return DarkCandy.db.profile.iconpos end,
					set = function (v) DarkCandy.db.profile.iconpos = v end,
					validate = {"RIGHT","LEFT"},
				},
			},
		},
		combat = {
			name = "Combat", 
			desc = "Toggles whether bars disappear when out of combat.", 
			type = "toggle",
			get = function() return DarkCandy.db.profile.fadeoncombat end,
			set = function(v)
				DarkCandy.db.profile.fadeoncombat = v 
				if v then
					DarkCandy:RegisterEvent("PLAYER_REGEN_ENABLED")
				else
					DarkCandy:UnregisterEvent("PLAYER_REGEN_ENABLED")
				end
			end
		},
		kill = {
			name = "Kill", 
			desc = "Toggles whether bars disappear when killing things.", 
			type = "toggle",
			get = function() return DarkCandy.db.profile.fadeonkill end,
			set = function(v)
				DarkCandy.db.profile.fadeonkill = v 
				if v then
					DarkCandy:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
				else
					DarkCandy:UnregisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
				end
			end
		},
		fade = {
			name = "Fade",
			desc = "Toggles whether bars disappear when spells fade.",
			type = "toggle",
			get = function() return DarkCandy.db.profile.fadeonfade end,
			set = function(v)
				DarkCandy.db.profile.fadeonfade = v
				if v then
					DarkCandy:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
				else
					DarkCandy:UnregisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
				end
			end
		},
	},
}

DarkCandy:RegisterDB("DarkCandyDB")
DarkCandy:RegisterDefaults('profile', DarkCandy.defaults)
DarkCandy:RegisterChatCommand({'/darkcandy'}, DarkCandy.options)

function DarkCandy:Setup()
	self:AddTimer(self.SPELL, "Banish", "Spell_Shadow_Cripple", 30, { gr=1, rt={20} })
	self:AddTimer(self.SPELL, "Corruption", "Spell_Shadow_AbominationExplosion", 18, { gr=2, rt={12,15} })
	self:AddTimer(self.SPELL, "Curse of Agony", "Spell_Shadow_CurseOfSargeras", 24, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of Doom", "Spell_Shadow_AuraOfDarkness", 60, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of Exhaustion", "Spell_Shadow_GrimWard", 12, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of Recklessness", "Spell_Shadow_UnholyStrength", 120, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of Shadow", "Spell_Shadow_CurseOfAchimonde", 300, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of Tongues", "Spell_Shadow_CurseOfTounges", 30, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of Weakness", "Spell_Shadow_CurseOfMannoroth", 120, { gr=3 })
	self:AddTimer(self.SPELL, "Curse of the Elements", "Spell_Shadow_ChillTouch", 300, { gr=3 })
	self:AddTimer(self.SPELL, "Death Coil", "Spell_Shadow_DeathCoil", 3, { gr=4 })
	self:AddTimer(self.SPELL, "Fear", "Spell_Shadow_Possession", 20, { gr=5, rt={10,15} })
	self:AddTimer(self.SPELL, "Howl of Terror", "Spell_Shadow_DeathScream", 8, { gr=6, rt={6} })
	self:AddTimer(self.SPELL, "Immolate", "Spell_Fire_Immolation", 15, { gr=7 })
	self:AddTimer(self.SPELL, "Shadowfury", "Spell_Shadow_Shadowfury", 2, { gr=8 })
	self:AddTimer(self.SPELL, "Siphon Life", "Spell_Shadow_Requiem", 30, { gr=9 })
	self:AddTimer(self.SPELL, "Unstable Affliction",  "Spell_Shadow_UnstableAffliction_3", 18, { gr=10 })
	self:AddTimer(self.SPELL, "Enslave Demon", "Spell_Shadow_EnslaveDemon", 300, { gr=11 })
	self:AddTimer(self.SPELL, "Conflagrate", "", 0, { r="Immolate" })	
	self:AddTimer(self.EVENT, "Seduction", "Spell_Shadow_MindSteal", 15, { gr=12 })
end

function DarkCandy:OnEnable()
	DewDrop:InjectAceOptionsTable(self, self.options)

	self:RegisterChatCommand('/darkcandy', {
		type = 'execute',
		func = function()
			DewDrop:Open("DarkCandy")
		end
	})

	DewDrop:Register("DarkCandy",
		'children', DarkCandy.options,
		'cursorX', true,
		'cursorY', true
	)

	-- create the anchor frame
	self:CreateAnchor()

	self:RegisterCandyBarGroup("DarkCandy")
	self:SetCandyBarGroupPoint("DarkCandy", "TOPLEFT", self.anchor, "TOPLEFT", 0, 0)
	self:SetCandyBarGroupGrowth("DarkCandy", self.db.profile.growup)

	self:Setup()

	-- On-Kill handling
	if self.db.profile.fadeonkill then
		self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	end

	-- Spell fade handling
	if self.db.profile.fadeonfade then
		self:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
	end

	-- Pet spell handling
	self:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE")
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE", "SPELL_PERIODIC")
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE", "SPELL_PERIODIC")
	
	-- Combat handling
	if self.db.profile.fadeoncombat then
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
	
	-- Spellcast handling
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	
	-- Fail/Miss handling
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
end

function DarkCandy:OnDisable()
	for k,_ in pairs(spellBars) do
		self:KillBars(k)
	end
	self:UnregisterAllEvents()
end

function DarkCandy:RGBToHex(r, g, b)
	return format("%02x%02x%02x", r*255, g*255, b*255)
end

function DarkCandy:AddTimer(kind, name, icon, duration, extra)
	if not timers[kind] then timers[kind] = new()		 end
	if not timers[kind][name] then timers[kind][name] = new() end
	timers[kind][name] = { i=icon, d=duration, gr=(extra.gr or nil), rt=(extra.rt or nil),r=(extra.r or nil) }
end

function DarkCandy:StartTimer(timer, name, target, rank, durmod)
	if not spellBars[target] then spellBars[target] = new() end

	-- Remove group spells, there can be only one
	local group = timer.gr
	if group then
		for _, v in ipairs(spellBars[target]) do
			if v.group == group then
				self:SetCandyBarFade(v.id, 0, false)
				self:StopCandyBar(v.id)
				v = del(v)
				break
			end
		end
	end

	-- Create us a new bar and insert it
	local id = name .. "-" .. target
	local bar = new()
	bar.id, bar.name, bar.group = id, name, timer.gr
	table.insert(spellBars[target], bar)

	rank = rank or 0
	local duration = ((timer.rt and timer.rt[rank]) or timer.d) + (durmod or 0) 
	local text = (target == "none" and name) or target .. " - " .. name
	local icon = "Interface\\Icons\\" .. timer.i

	local db = self.db.profile
	self:RegisterCandyBar(id, duration, text, icon, db.barcolor)
	self:RegisterCandyBarWithGroup(id, "DarkCandy")
    self:SetCandyBarFade(id, 0.5)
	self:SetCandyBarIconPosition(id, db.iconpos)
	self:SetCandyBarScale(id, db.scale)
	self:SetCandyBarWidth(id, db.width)
	self:SetCandyBarHeight(id, db.height)
	self:SetCandyBarTexture(id, Media:Fetch("statusbar", db.texture))
	self:SetCandyBarBackgroundColor(id, db.bgcolor, db.bgalpha)
	self:SetCandyBarCompletion(id, self.KillBar, self, id, target)
	self:SetCandyBarReversed(id, db.reverse)
	self:SetCandyBarOnClick(id, function(id, button) self:OnClick(id, button) end)
	self:StartCandyBar(id, true)
end

function DarkCandy:IsBanished(target)
	local bars = spellBars[target]
	if bars then
		for _, v in ipairs(bars) do
			if v.name == "Banish" then
				return true
			end
		end
	end
	return false
end

function DarkCandy:KillBar(id, target)
	local bars = spellBars[target]
	if bars then
		for _, v in ipairs(bars) do
			if v.id == id then
				self:StopCandyBar(v.id)
				v = del(v)
				break
			end
		end
	end
end

function DarkCandy:KillBars(target)
	if UnitExists("target") and 
		UnitName("target") == target and 
		not UnitIsDeadOrGhost("target") then 
			return 
	end
	
	local bars = spellBars[target]
	if bars then
		for _, v in ipairs(bars) do
			if v.id then
				self:StopCandyBar(v.id)
				v = del(v)
			end
		end
		spellBars[target] = del(spellBars[target])
	end
end

function DarkCandy:ReportStatus(id, target)
	local bars = spellBars[target]
	if bars then
		for _, v in ipairs(bars) do
			if v.id == id then
				local reg, t, e, r = self:CandyBarStatus(id)
				local gr = nil
				if UnitInRaid("player") then 
					gr = "RAID"
				elseif GetNumPartyMembers() > 0 then 
					gr = "PARTY"
				end
				SendChatMessage(v.name .. " fades in " .. string.format( "%.1f", t - e) .. "s", gr)
				break
			end
		end
	end
end

function DarkCandy:OnClick(id, button)
	local target = string.match(id, "-(.+)")
	if button == "RightButton" then
		self:KillBar(id, target)
	elseif button == "LeftButton" then
		self:ReportStatus(id, target)
	end
end

function DarkCandy:CreateAnchor()
	self.anchor = CreateFrame("Button", nil, UIParent)
	self.anchor:SetClampedToScreen(true)
	
	local db = self.db.profile

	self.anchor:SetWidth(db.width)
	self.anchor:SetHeight(db.height)

	if db.pos.x and db.pos.y then
		self.anchor:ClearAllPoints()
		self.anchor:SetPoint("TOPLEFT", UIParent, "TOPLEFT", db.pos.x, db.pos.y)
	else
		self.anchor:SetPoint("CENTER", UIParent, "CENTER", 0, 50)
	end

	self.anchor:SetScript("OnDragStart", function() this:StartMoving() end )
	self.anchor:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()
		local _, _, _, x, y = this:GetPoint()
		DarkCandy.db.profile.pos.x = math.floor(x)
		DarkCandy.db.profile.pos.y = math.floor(y)
	end)

	self.anchor:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "",
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 0, right =0, top = 0, bottom = 0 
	}})
	self.anchor:SetBackdropColor(0,1,0,.6)
	self.anchor:SetMovable(true)
	self.anchor:RegisterForDrag("LeftButton")

	self.anchor.Text = self.anchor:CreateFontString(nil, "OVERLAY")
	self.anchor.Text:SetFontObject(GameFontNormalSmall)
	self.anchor.Text:ClearAllPoints()
	self.anchor.Text:SetTextColor(1, 1, 1, 1)
	self.anchor.Text:SetWidth(200)
	self.anchor.Text:SetHeight(25)
	self.anchor.Text:SetPoint("TOP", self.anchor, "TOP")
	self.anchor.Text:SetJustifyH("CENTER")
	self.anchor.Text:SetJustifyV("MIDDLE")
	self.anchor.Text:SetText("DarkCandy")

	self.anchor:Hide()
end

function DarkCandy:PLAYER_REGEN_ENABLED()
	for k,_ in pairs(spellBars) do
		self:KillBars(k)
	end
end

function DarkCandy:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
    local target = msg:match(pattern.death)
	if target and not self:IsBanished(target) then
		return self:KillBars(target)
	end
end

function DarkCandy:CHAT_MSG_SPELL_AURA_GONE_OTHER(msg)
	local debuff, target = msg:match(pattern.aura_gone)
	
	if debuff == "Banish" then return end
	self:KillBar(debuff .. "-" .. target, target)
end

function DarkCandy:CHAT_MSG_SPELL_PET_DAMAGE(msg)
	local source, debuff = msg:match(pattern.pet_damage)
	if source ~= UnitName("pet") then return end
	petcomplete.skill = debuff
end

-- This is strictly to catch pet casts
function DarkCandy:SPELL_PERIODIC(msg)
	local target, debuff = msg:match(pattern.periodic)	
	if debuff ~= petcomplete.skill then return end
	
	petcomplete.skill = nil
	
	local timer = timers[self.EVENT][debuff]
	if timer then
		self:StartTimer(timer, debuff, target)
	end
end

function DarkCandy:GetRankNumber(rank)
	local r = string.match(rank, "%d+")
	return tonumber(r)
end

function DarkCandy:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
	if unit ~= "player" then return end
	
	local timer = timers[self.SPELL][spell]
	if timer then
		complete.timer, complete.spell, complete.rank, complete.target = timer, spell, self:GetRankNumber(rank), target
	end
end

function DarkCandy:UNIT_SPELLCAST_SUCCEEDED(unit, spell, rank)
	if unit ~= "player" then return end
	
	local rank = self:GetRankNumber(rank)
	if complete.spell == spell and complete.rank == rank then
		if complete.timer.r then
			self:KillBar(complete.timer.r .. "-" .. complete.target, complete.target)
		elseif complete.target == "none" then
			self:StartTimer(complete.timer, complete.spell, complete.target, complete.rank)
			complete.spell = nil
            complete.rank = nil
		else
			local active = new()
			active.timer, active.spell, active.rank, active.target = complete.timer, complete.spell, complete.rank, complete.target
			activeSpells[spell] = active
			self:ScheduleEvent(self.CompleteCast, 0.3, self, complete.spell)
		end
	end
end

function DarkCandy:CompleteCast(spell)
	local active = activeSpells[spell]
	if active then
		self:StartTimer(active.timer, active.spell, active.target, active.rank, -0.3)
		activeSpells[spell] = del(activeSpells[spell])
	end
end

-- Lifted from spellwatch with some modifications
function DarkCandy:CHAT_MSG_SPELL_SELF_DAMAGE(msg)
	local spell, target = msg:match(pattern.resist)
	if not spell or not target then spell, target = msg:match(pattern.missed) end
	if not spell or not target then spell, target = msg:match(pattern.fail) end
	if not spell or not target then target, spell = msg:match(pattern.immune) end
	if not spell or not target then spell, target = msg:match(pattern.evade) end
	if not spell or not target then spell, target = msg:match(pattern.reflect) end
	if not spell or not target then return end

	local active = activeSpells[spell]
	if active and target == active.target then
		activeSpells[spell] = del(activeSpells[spell])
	end
end